; Logier's Annual 2024 Christmas Present coding compeition.
; Submission for the Laser 500 computer.
; -Dave / Bushy555.
;
;
; File details
; =======================
;   16 bytes :  Loading header. 
;  103 bytes :  code
;  119 bytes :  total file size.
;  368 bytes :  source code size.
;
;
;
;   Assembling
; =============
; 	Assemble with PASMO.EXE Z80 assembler.
; 	PASMO --alocal file.asm file.bin
;
;
;
; Instructions/sue
; ================
;   Resulting outtputed assembled .BIN file can be simply copied into an emulator, or, 
;   Use:   BIN2WAV to create a WAV file , that can then be CLOAD'd in.
;
; Use Antontino's Laser500 emulator :     https://nippur72.github.io/laser500emu/
; Drag and drop the .BIN file on to the emulator screen. Program will auto run.
; Execution assumptions:
; First program to run immediately after emulator has started.
;
; * Weird : can take up to three or four times for the emulator to successfully
;           display the Christmas Present box correctly. Unsure why.
;           Perhaps the speed of my old aging computer can not keep up?
; 	    It does eventually display the box correctly.
;
;
;
	org	$8995		; Loads BASIC header here.
;Add an execution basic 'RUN' header:
;Add a basic header so that the program can be "RUN"
;2021 A equ &H89A5:CALL A:END
;
   	db 	$FF,$FF,$E2,$07,$41,$F0,$0C,$A5,$89,$3A,$B6,$20,$41,$3A,$81,$00
;
;
;
;

;	di

	ld      hl, line1	; display Ribbon - first line
	call	display_hl	; call ROM display HL sub-routine.

	ld      hl, line2	; display top of box
	call	display_hl	; call ROM display HL sub-routine.


	ld	b, 2		; outside counter loop : 2 times.  2 to 1
loop0:	push	bc
	ld	b, 8		; inner count loop : 8 times. 8 to 1
loop1:	ld      hl, line3
	push	bc
	call	display_hl	; call ROM display HL sub-routine.
	pop	bc
	djnz	loop1		; loop back to loop1. Decrement reg B by one,

	ld      hl, line2
	call	display_hl	; call ROM display HL sub-routine.

	pop	bc		
	djnz	loop0		; loop back to loop0. Decrement reg B by one.

display_hl:
	call    $62d3		; ROM display calls
	call    $591c
	ret


line1:	db '        \O/',0		; Ribbon.
line2:	db $d,'+--------+--------+',0	; Top, middle, bottom of box
line3:	db $d,'!        !        !',0	; Middle bits of box.


; ld hl,d1
; ld de,$7008
; ld bc,3
; ldir
; call $2B75
; ld e,2
;a1:ld b,8
;b1:ld hl,f1
; call $2B75
; djnz b1
; ld hl,e1
; call $2B75
; dec e
; jr nz,a1
;c1:jr c1
;d1:db '\O',111
;e1:db $d,'+--------+--------+',0
;f1:db $d,'!        !        !'
;